package org.jvnet.jaxb2_commons.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.sun.tools.xjc.model.CAttributePropertyInfo;
import com.sun.tools.xjc.model.CClassInfo;
import com.sun.tools.xjc.model.CCustomizations;
import com.sun.tools.xjc.model.CElement;
import com.sun.tools.xjc.model.CElementPropertyInfo;
import com.sun.tools.xjc.model.CPluginCustomization;
import com.sun.tools.xjc.model.CPropertyInfo;
import com.sun.tools.xjc.model.CPropertyVisitor;
import com.sun.tools.xjc.model.CReferencePropertyInfo;
import com.sun.tools.xjc.model.CValuePropertyInfo;
import com.sun.tools.xjc.outline.ClassOutline;
import com.sun.tools.xjc.outline.FieldOutline;

public class CustomizationUtils {

	private static final DocumentBuilder DOCUMENT_BUILDER;
	static {
		final DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory
				.newInstance();
		try {
			DOCUMENT_BUILDER = documentBuilderFactory.newDocumentBuilder();
		} catch (ParserConfigurationException pce) {
			throw new ExceptionInInitializerError(pce);
		}
	}

	// public static Collection getCustomizations(CCustomizable customizable) {
	// CPluginCustomization
	// CCustomizations customizations2 = customizable.getCustomizations();
	// final Collection customizations = new ArrayList();
	// for (Iterator iterator = item.declarations.iterator();
	// iterator.hasNext();) {
	// final BIDeclaration declaration = (BIDeclaration) iterator.next();
	// if (declaration instanceof BIXPluginCustomization) {
	// customizations.add(declaration);
	// }
	// }
	// return customizations;
	// }

	public static CPluginCustomization createCustomization(QName name) {
		final Document document = DOCUMENT_BUILDER.newDocument();
		final Element element = document.createElementNS(
				name.getNamespaceURI(), name.getLocalPart());
		return createCustomization(element);
	}

	public static CPluginCustomization createCustomization(final Element element) {
		final CPluginCustomization customization = new CPluginCustomization(
				element, null);
		return customization;
	}

	//
	// public static BIXPluginCustomization getOrCreateCustomization(JavaItem
	// item, QName name) {
	// if (containsCustomization(item, name)) {
	// return getCustomization(item, name);
	// }
	// else {
	// final BIXPluginCustomization customization = createCustomization(name);
	// item.declarations.add(customization);
	// return customization;
	// }
	// }

	// public static CPluginCustomization[] getCustomizations(CCustomizable
	// item, QName name) {
	//	  
	// item.getCustomizations().
	// final Collection customizationsDraft = getCustomizations(item);
	// final Collection customizations = new ArrayList();
	//
	// for (Iterator iterator = customizationsDraft.iterator();
	// iterator.hasNext();) {
	// final BIXPluginCustomization customization = (BIXPluginCustomization)
	// iterator.next();
	//
	// final Element element = customization.element;
	// if (null != element) {
	// final QName elementName = new QName(element.getNamespaceURI(),
	// element.getLocalName());
	// if (elementName.equals(name))
	// customizations.add(customization);
	// }
	// }
	// return (BIXPluginCustomization[]) customizations
	// .toArray(new BIXPluginCustomization[customizations.size()]);
	// }

	public static boolean containsCustomization(ClassOutline classOutline,
			QName name) {
		final CCustomizations customizations = CustomizationUtils
				.getCustomizations(classOutline);
		return customizations.find(name.getNamespaceURI(), name.getLocalPart()) != null;
		// for (Iterator iterator = item.declarations.iterator();
		// iterator.hasNext();) {
		// final BIDeclaration declaration = (BIDeclaration) iterator.next();
		// if (declaration instanceof BIXPluginCustomization) {
		// final BIXPluginCustomization customization = (BIXPluginCustomization)
		// declaration;
		// if (name.equals(customization.getName())) {
		// return true;
		// }
		// }
		// }
		// return false;
	}

	public static boolean containsCustomization(FieldOutline fieldOutline,
			QName name) {
		final CCustomizations customizations = CustomizationUtils
				.getCustomizations(fieldOutline);
		return customizations.find(name.getNamespaceURI(), name.getLocalPart()) != null;
		// for (Iterator iterator = item.declarations.iterator();
		// iterator.hasNext();) {
		// final BIDeclaration declaration = (BIDeclaration) iterator.next();
		// if (declaration instanceof BIXPluginCustomization) {
		// final BIXPluginCustomization customization = (BIXPluginCustomization)
		// declaration;
		// if (name.equals(customization.getName())) {
		// return true;
		// }
		// }
		// }
		// return false;
	}

	// public static BIXPluginCustomization getCustomization(JavaItem item,
	// QName name) {
	// final BIXPluginCustomization[] customizations = getCustomizations(item,
	// name);
	// if (customizations == null || customizations.length < 1) {
	// return null;
	// }
	// else {
	// return customizations[0];
	// }
	// }

	public static FieldOutline findFieldWithCustomization(
			ClassOutline classOutline, final QName name) {

		// final FieldUse[] fieldUses =
		// classContext.target.getDeclaredFieldUses();
		// for (int index = 0; index < fieldUses.length; index++) {
		// final FieldUse fieldUse = fieldUses[index];
		// final FieldItem draftFieldItem = FieldUtils.getFieldItem(fieldUse);
		//
		// if (containsCustomization(draftFieldItem, name)) {
		// return draftFieldItem;
		// }
		// }
		// return null;

		for (final FieldOutline fieldOutline : classOutline.getDeclaredFields()) {
			final CCustomizations customizations = getCustomizations(fieldOutline);
			final CPluginCustomization customization = customizations.find(name
					.getNamespaceURI(), name.getLocalPart());
			if (customization != null)
				return fieldOutline;
		}
		return null;

	}

	public static FieldOutline findInheritedFieldWithCustomization(
			ClassOutline classOutline, final QName name) {
		for (final FieldOutline fieldOutline : classOutline.getDeclaredFields()) {
			if (containsCustomization(fieldOutline, name)) {
				return fieldOutline;
			}
		}
		final ClassOutline superClassOutline = classOutline.getSuperClass();
		if (superClassOutline != null) {
			return findInheritedFieldWithCustomization(superClassOutline, name);
		} else {
			return null;
		}
	}

	public static CCustomizations getCustomizations(FieldOutline fieldOutline) {
		return getCustomizations(fieldOutline.getPropertyInfo());
	}

	public static CCustomizations getCustomizations(
			final CPropertyInfo propertyInfo) {

		final CCustomizations main = propertyInfo.getCustomizations();

		final Collection<CCustomizations> elementCustomizations = propertyInfo
				.accept(new CPropertyVisitor<Collection<CCustomizations>>() {
					public Collection<CCustomizations> onAttribute(
							CAttributePropertyInfo info) {
						return Collections.emptyList();
					}

					public Collection<CCustomizations> onElement(
							CElementPropertyInfo arg0) {
						return Collections.emptyList();
					}

					public Collection<CCustomizations> onReference(
							CReferencePropertyInfo info) {

						final List<CCustomizations> elementCustomizations = new ArrayList<CCustomizations>(
								info.getElements().size());

						for (CElement element : info.getElements()) {
							elementCustomizations.add(element
									.getCustomizations());
						}

						return elementCustomizations;
					}

					public Collection<CCustomizations> onValue(
							CValuePropertyInfo arg0) {
						return Collections.emptyList();
					};

				});

		CCustomizations customizations = main;

		for (CCustomizations e : elementCustomizations) {
			customizations = CCustomizations.merge(customizations, e);
		}

		return customizations;
	}

	public static CCustomizations getCustomizations(ClassOutline classOutline) {
		return getCustomizations(classOutline.target);
	}

	public static CCustomizations getCustomizations(final CClassInfo classInfo) {
		return classInfo.getCustomizations();
	}

}
